classdef Cloud < handle

    properties (SetAccess=private)
        FreeProcessorsMap
        totalUsageProcs
        UsageMap
        NumUsedProcs
        usageVect
    end
    properties
        NC
        N
        C
        B
        I
        W
        CInit
        BInit     
        NCvect
        Nobj
        Nfree
        ClustSize
    end
    methods
        function c=Cloud(C,B,I,NCvect,Duration,Window,Nclusters,ClustSize)
            c.CInit=C;
            c.BInit=B;            
            c.C=C;
            c.B=B;
            c.I=I;
            c.NC=Nclusters;
            c.NCvect=NCvect;
            c.N=length(C);
            c.W=Window;
            c.NumUsedProcs=zeros(Duration,1);
            c.totalUsageProcs=zeros(Duration,1);
            c.usageVect=zeros(Window,c.N);
            c.ClustSize=ClustSize;
        end
        function updateTime(C,t)
            w=mod(t,C.W);
            w(w==0)=1;
            C.usageVect(w,:)=C.C(1:C.N)./C.CInit(1:C.N);
            C.NumUsedProcs(t)=sum(C.CInit>C.C);  
            C.totalUsageProcs(t)=mean(ones(size(C.C))-C.C./C.CInit);
        end
        function procs=usageProcsVect(C,t)
            t=mod(t,C.W);
            t(t==0)=1;
            procs=C.usageVect(t,:);
        end
        
        function procs=numUsedProcs(C,t)
            procs=C.NumUsedProcs(t);
        end
        function procs=usageProcs(C,t)
            procs=C.totalUsageProcs(t);
        end
        function procs=freeProcsMap(C)
            procs=(C.CInit==C.C);
        end
        function procs=usageProcsMap(C)
            procs=(C.CInit-C.C)./C.CInit;
        end
        function bw=usageBWMap(C)
            bw=(C.BInit-C.B)./C.BInit;
        end
    end
end