function varargout = gui(varargin)
% GUI M-file for gui.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui

% Last Modified by GUIDE v2.5 26-May-2012 13:44:26

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);               
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


function Nops=getNops(handles)
    if get(handles.popupmenu2,'Value')==1
        Nops=str2num(get(handles.edit9,'String'));
    elseif get(handles.popupmenu2,'Value')==2
        x=str2num(get(handles.edit9,'String'));
        Nops=length(x);
    elseif get(handles.popupmenu2,'Value')==3
        s=get(handles.edit9,'String');
        x=s(1:find(',')+1);
        Nops=str2num(x);
    end
    
 function [CellsX CellsY] = getNcells(handles)
    CellsX=str2num(get(handles.edit1,'String'))/str2num(get(handles.edit5,'String'));
    CellsY=str2num(get(handles.edit2,'String'))/str2num(get(handles.edit6,'String'));
    

     
function Nclusters=getNclusters(handles)
    Nclusters=str2num(get(handles.numClusters,'String'));
    

function [C B I]=getCBI(handles)

    if (get(handles.checkbox3,'Value')==1)
        inf = 10000000;
        Cx=str2num(get(handles.edit16,'String'));
        Bx=str2num(get(handles.edit17,'String'));
        Ncores=str2num(get(handles.edit38,'String'));
        C=Cx.*ones(1,Ncores);
        B=[inf.*ones(1,Ncores) Bx zeros(1,Ncores^2-1-Ncores)];
        I=diag(1:Ncores)+(Ncores+1)*(ones(Ncores,Ncores)-eye(Ncores));
    else
        if ~isempty(get(handles.edit42,'String'))
            f=str2func(get(handles.edit42,'String'));
            [C B I]=f();
        else
            C=0;
            B=0;
            I=0;
        end
        
    end
        
function updateCellNumber(handles)
    [CellsX CellsY]=getNcells(handles);
    
    [C]=getCBI(handles);
    Cclust=sum(C);
    Nprocs=length(C);
    
    set(handles.text8,'String',sprintf('%dx%d Cells',CellsX,CellsY));
    set(handles.text43,'String',sprintf('%d Clusters',getNclusters(handles)));
    set(handles.text44,'String',sprintf('%d Processors',getNclusters(handles)*Nprocs));
    set(handles.text47,'String',sprintf('%g GMOPTS/Cluster',Cclust/1000));
    set(handles.text48,'String',sprintf('%.3f TMOPTS',Cclust*getNclusters(handles)/1000000));


% --- Executes on selection change in popupmenu10.
function popupmenu10_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu10 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu10

if get(handles.popupmenu10,'Value')==1
    set(handles.popupmenu18,'Value',1);
elseif get(handles.popupmenu10,'Value')==5
    set(handles.popupmenu18,'Value',4);
elseif get(handles.popupmenu10,'Value')==6
    set(handles.popupmenu18,'Value',4);
elseif get(handles.popupmenu10,'Value')==7
    set(handles.popupmenu18,'Value',4);
elseif get(handles.popupmenu10,'Value')==8
    set(handles.popupmenu18,'Value',4);
elseif get(handles.popupmenu10,'Value')==9
    set(handles.popupmenu18,'Value',7);
elseif get(handles.popupmenu10,'Value')==10
    set(handles.popupmenu18,'Value',3);
elseif get(handles.popupmenu10,'Value')==11
    set(handles.popupmenu18,'Value',7);
elseif get(handles.popupmenu10,'Value')==12
    set(handles.popupmenu18,'Value',4);
elseif get(handles.popupmenu10,'Value')==13
    set(handles.popupmenu18,'Value',1);
elseif get(handles.popupmenu10,'Value')==15
    set(handles.popupmenu18,'Value',3);
else
    set(handles.popupmenu18,'Value',2);
end;
updatePlot(handles.axes1,handles);

function [p AxisMax]=computePlot(handles)

    S=getappdata(handles.figure1,'Scenario');
    j=get(handles.popupmenu15,'Value');
    t=[];
    
    operator=get(handles.popupmenu11,'Value')-1;
    service=get(handles.popupmenu16,'Value')-1;
       
    mapTime=S.Strategies(j).mappingTime(operator,service);
    
    %All Users
    if get(handles.popupmenu10,'Value')==1
        [x y c] = S.getUsersXY(operator,service);    
        p=[x; y; c];
        AxisMax=max(c);
    elseif get(handles.popupmenu10,'Value')==2
        %Users per Cell
        p=S.Strategies(j).UsersMap(operator,service);
        AxisMax=max(max(max(p)));
    elseif get(handles.popupmenu10,'Value')==3
        %Feasible Users
        p=S.Strategies(j).FeasibleUsersMap(operator,service)./S.Strategies(j).UsersMap(operator,service);
        p(isnan(p))=0;
        AxisMax=1;
    elseif get(handles.popupmenu10,'Value')==4
        %Unfeasible Users
        p=S.Strategies(j).UnfeasibleUsersMap(operator,service)./S.Strategies(j).UsersMap(operator,service);
        p(isnan(p))=0;
        AxisMax=1;
    elseif  get(handles.popupmenu10,'Value')==5
        %Number of used processor
        [p t]=S.Strategies(j).vectorActiveProcessors();
        AxisMax=1.5*max(p);
    elseif  get(handles.popupmenu10,'Value')==6
        %Total processor Utilization
        [p t]=S.Strategies(j).vectorUsageProcessors();
        AxisMax=1.5*max(p);
    elseif get(handles.popupmenu10,'Value')==7
        % Number of Total users
        [p t]=S.Strategies(j).vectorUsers();
        AxisMax=1.5*max(p);
    elseif get(handles.popupmenu10,'Value')==8
        % Number of Feasible users            
        [p t]=S.Strategies(j).vectorFeasibles();
        AxisMax=1.5*max(p);
    elseif get(handles.popupmenu10,'Value')==9
        % C usage map
        p=S.Strategies(j).usageProcessorsMap();
        p=p';
        AxisMax=1;
    elseif get(handles.popupmenu10,'Value')==10
        % C usage time
        [p t]=S.Strategies(j).usageProcessorsTime();
        AxisMax=1;
    elseif get(handles.popupmenu10,'Value')==11
        % BW usage map
        p=S.Strategies(j).usageBWMap();
        p=p';
        AxisMax=1;
    elseif  get(handles.popupmenu10,'Value')==12
        %Execution time            
        p=mapTime;
        AxisMax=2*max(p);
    elseif  get(handles.popupmenu10,'Value')==14
        [x y c] = S.getUsersXY(operator,service,j);    
        p=[x; y; c];
        AxisMax=max(c);
    elseif  get(handles.popupmenu10,'Value')==15
        p = S.Strategies(j).usageClustersTime();  
        AxisMax=1; 
    elseif  get(handles.popupmenu10,'Value')==16
        for i=1:length(S.Strategies)
            [p(:,i) t(i,:)]=S.Strategies(i).vectorFeasibles();
        end;          
        AxisMax=1.5*max(max(p)); 
    end
    
    
    
function res=updatePlot(axes,handles)
    
    S=getappdata(handles.figure1,'Scenario');
    j=get(handles.popupmenu15,'Value');
    t=[];
    
    operator=get(handles.popupmenu11,'Value')-1;
    service=get(handles.popupmenu16,'Value')-1;
       
    mapTime=S.Strategies(j).mappingTime(operator,service);

    
    
    areaXY=getappdata(handles.figure1,'AreaXY');
    CellXY=getappdata(handles.figure1,'CellXY');

    Nx=areaXY.x/CellXY.x;
    Ny=areaXY.y/CellXY.y;
    
    if get(handles.popupmenu10,'Value')==13
        f=str2func(get(handles.edit25,'String'));
        f(axes,S.Strategies(j),S);        
    else
        [p AxisMax]=computePlot(handles);
        if get(handles.popupmenu18,'Value')==1
            scatter(axes,p(1,:),p(2,:),5,p(3,:));
        elseif get(handles.popupmenu18,'Value')==2
            surf(axes,p);
            axis([0 Nx 0 Ny 0 AxisMax]);
        elseif get(handles.popupmenu18,'Value')==3
            a=pcolor(axes,p');
            set(a,'LineStyle','none')
        elseif get(handles.popupmenu18,'Value')==4
            if (isempty(t))
                plot(axes,p);
            else
                plot(axes,p(1:length(t),1));
            end;
            %axis([0 Nx 0 AxisMax]);
        elseif get(handles.popupmenu18,'Value')==5
            stem3(axes,p);
            %axis([0 Nx 0 AxisMax]);
        elseif get(handles.popupmenu18,'Value')==6
            image(p,'Parent',axes);
            %axis([0 Nx 0 AxisMax]);
        elseif get(handles.popupmenu18,'Value')==7
            bar(axes,p);
        end;
    end;
    
    res=1;
    
    set(handles.text37,'String',sprintf('Users: %d',S.Strategies(j).numUsers(operator,service)));
    set(handles.text38,'String',sprintf('Feasibles: %d (%.2f%%)',S.Strategies(j).numFeasibles(operator,service),100*S.Strategies(j).numFeasibles(operator,service)/S.Strategies(j).numUsers(operator,service)));
    set(handles.text40,'String',sprintf('Mapping Time: %.2f ms',1000*mean(mapTime)));        
    if (S.simTime>0)
        set(handles.text41,'String',sprintf('Used Procs: %d',S.Strategies(j).numUsedProcs()));
    end;   


% --- Executes just before gui is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui (see VARARGIN)

% Choose default command line output for gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

S=getappdata(handles.figure1,'Scenario');
set(handles.pushbutton6,'Enable','off');
set(handles.pushbutton1,'Enable','off');
set(handles.pushbutton8,'Enable','off');
h=waitbar(0,'Simulating...');
S.run(S.Duration);
delete(h);
updatePlot(handles.axes1,handles);
set(handles.pushbutton8,'Enable','on');

set(handles.pushbutton6,'Enable','off');
set(handles.pushbutton1,'Enable','off');

function edit1_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit1 as text
%        str2double(get(hObject,'String')) returns contents of edit1 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function popupmenu6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function popupmenu7_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function popupmenu8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit16_Callback(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
updateCellNumber(handles)

function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double

updateCellNumber(handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit5_Callback(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit5 as text
%        str2double(get(hObject,'String')) returns contents of edit5 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

if get(hObject,'Value')==1
    set(handles.edit8,'TooltipString','No options');
    set(handles.edit8,'String','');
elseif get(hObject,'Value')==2
    set(handles.edit8,'TooltipString','Setup gaussian options vector: [mean_x mean_y sigma_x sigma_y]');
    set(handles.edit8,'String','[mean_x mean_y sigma_x sigma_y]');
elseif get(hObject,'Value')==3
    set(handles.edit8,'TooltipString','Select a custom distribution function.Function: xy=positionDist(Scenario,N).N is the number of positions to generate and xy is an xy position class.');
    set(handles.edit8,'String','customfunc');
end;


% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double


% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2

if get(hObject,'Value')==1
    set(handles.edit9,'TooltipString','Introduce the number of operators');
    set(handles.edit9,'String','NumOperators');
elseif get(hObject,'Value')==2
    set(handles.edit9,'TooltipString','Setup a vector of distributions for each operator');
    set(handles.edit9,'String','[Pop1 Pop2 Pop3 ...]');
elseif get(hObject,'Value')==3
    set(handles.edit9,'TooltipString','Select a custom distribution function and the number of operators (Nops, customfunc). Function: op=operatorDist(Scenario,position). Where position is a vector of xy positions and op is a vector of operator indices');
    set(handles.edit9,'String','Nops, customfunc');
end;
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit9_Callback(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit9 as text
%        str2double(get(hObject,'String')) returns contents of edit9 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit9_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3
if get(hObject,'Value')==1
    set(handles.edit10,'TooltipString','Select a service. (1: 64kbps, 2:128kbps, 3:384kbps)');
    set(handles.edit10,'String','1');
elseif get(hObject,'Value')==2
    set(handles.edit10,'TooltipString','Setup a vector of distributions for each service, e.g. [P_1 P_2 P_3], (1: 64kbps, 2:128kbps, 3:384kbps)');
    set(handles.edit10,'String','[P_1 P_2 P_3]');
elseif get(hObject,'Value')==3
    set(handles.edit10,'TooltipString','Select a custom distribution function. Function: serv=serviceDist(Scenario,position, ops). Where position is a vector of xy positions, ops is a vector of operator indices and serv is a vector of Service class {c,b}');
    set(handles.edit10,'String','customfunc');
end;

% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit10 as text
%        str2double(get(hObject,'String')) returns contents of edit10 as a double


% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu4 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu4
if get(hObject,'Value')==1
    set(handles.text17,'String','Number of Users');
    set(handles.edit11,'TooltipString','Enter number of users');
    set(handles.edit12,'Enable','off');
elseif get(hObject,'Value')==2
    set(handles.text17,'String','Simulation Time');
    set(handles.edit11,'TooltipString','Enter the number of M/M/1 realizations');
    set(handles.edit12,'Enable','on');
    set(handles.edit12,'TooltipString','Enter M/M/1 values: [lamda mu]');
    set(handles.edit12,'String','[1 1]');
elseif get(hObject,'Value')==3
    set(handles.text17,'String','Simulation Time');
    set(handles.edit11,'TooltipString','Enter the number of M/M/1 realizations');
    set(handles.edit12,'Enable','on');
    set(handles.edit12,'TooltipString','Enter interval and load values: [Tend1 rho1;Tend2 rho2;...]');
    set(handles.edit12,'String','[1000 1;2000 10]');
elseif get(hObject,'Value')==4
    set(handles.text17,'String','Simulation Time');
    set(handles.edit11,'TooltipString','Enter the number of realizations');
    set(handles.edit12,'Enable','on');
    set(handles.edit12,'TooltipString','Custom event function. event=newEvent(N). Returns N simulation events: 0: do nothing, 1: user enters, 2: user exits');
    set(handles.edit12,'String','customfunc');
end;

% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit11_Callback(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit11 as text
%        str2double(get(hObject,'String')) returns contents of edit11 as a double


% --- Executes during object creation, after setting all properties.
function edit11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit12 as text
%        str2double(get(hObject,'String')) returns contents of edit12 as a double


% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu5.
function popupmenu5_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu5 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu5


% --- Executes during object creation, after setting all properties.
function popupmenu5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit13 as text
%        str2double(get(hObject,'String')) returns contents of edit13 as a double


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit14 as text
%        str2double(get(hObject,'String')) returns contents of edit14 as a double


% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double


% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit17_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit18_Callback(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit18 as text
%        str2double(get(hObject,'String')) returns contents of edit18 as a double


% --- Executes during object creation, after setting all properties.
function edit18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes during object creation, after setting all properties.
function popupmenu10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu11.
function popupmenu11_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu11 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu11

if get(handles.popupmenu11,'Value')==1
    set(handles.popupmenu16,'String','All Users')
    set(handles.popupmenu16,'Enable','off');
elseif get(handles.popupmenu11,'Value')==2
    set(handles.popupmenu16,'Enable','on');
    x=[];
    Nops=getappdata(handles.figure1,'Nops');
    for i=1:Nops
        x=strvcat(x,sprintf('Operator %d',i));
    end;
    set(handles.popupmenu16,'String',x);
elseif get(handles.popupmenu11,'Value')==3
    set(handles.popupmenu16,'Enable','on');
    x=[];
    if get(handles.popupmenu3,'Value')==1
        N=1;
    elseif get(handles.popupmenu3,'Value')==2
        N=length(str2num(get(handles.edit10,'String')));
    elseif get(handles.popupmenu3,'Value')==3
        f=str2func(get(handles.edit10,'String'));
        N=f();
    end;
    for i=1:N
        x=strvcat(x,sprintf('Service %d',i));
    end;
    set(handles.popupmenu16,'String',x);    
end;

updatePlot(handles.axes1,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit20_Callback(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit20 as text
%        str2double(get(hObject,'String')) returns contents of edit20 as a double
updatePlot(handles.axes1,handles);

% --- Executes during object creation, after setting all properties.
function edit20_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit20 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit21_Callback(hObject, eventdata, handles)
% hObject    handle to clustMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clustMat as text
%        str2double(get(hObject,'String')) returns contents of clustMat as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function clustMat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to clustMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit22_Callback(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit22 as text
%        str2double(get(hObject,'String')) returns contents of edit22 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit22_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit22 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function strat=saveStrat(handles)

mapConf = mappingConfig;
% Define other algorithms parameters
mapConf.w=str2num(get(handles.edit13,'String')); % algorithm window (for tw-mapping)
mapConf.alg=get(handles.popupmenu5,'Value')-1; % algorithm selector: 0=gw-mapping, 1=tw-mapping, 2=opt-mapping
mapConf.ord=get(handles.popupmenu7,'Value')-1; % pre-processing order: 0=no order, 1=capacity order, 2=bw order
mapConf.mhop=get(handles.popupmenu8,'Value')-1; % enable multi-hop: 0=no, 1=yes
mapConf.d=str2num(get(handles.edit14,'String'));
mapConf.q=str2num(get(handles.edit15,'String'));
mapConf.weight=0;
customAlg=get(handles.edit28,'String');
%mapConf.force_idx=str2num(get(handles.edit18,'String'));

DCmodel=get(handles.dcModel,'Value');
Nclusters=getNclusters(handles);
DCcustom=get(handles.DCcustom,'String');
HLmapping=get(handles.HLmap,'String');
[C B I]=getCBI(handles);
Idstr=get(handles.genTopology,'String');
Bd=str2num(get(handles.edit40,'String'));
Cluster=struct('C',C,'B',B,'I',I);
ClusterStr=struct('C',get(handles.edit16,'String'),'B',get(handles.edit17,'String'),'Custom',get(handles.edit42,'String'),'Multi',get(handles.checkbox3,'Value'),'Ncores',get(handles.edit38,'String'));
strat=struct('conf',mapConf,'clust',Cluster,'clustStr',ClusterStr,'DCmodel',DCmodel,'Nclusters',Nclusters,'DCcustom',DCcustom,'HLmapping',HLmapping,'enable',get(handles.checkbox2,'Value'),'customAlg',customAlg,'Idstr',Idstr,'Bd',Bd);



function loadStrat(handles,strat)
    set(handles.edit13,'String',num2str(strat.conf.w));
    set(handles.popupmenu5,'Value',strat.conf.alg+1);
    set(handles.popupmenu7,'Value',strat.conf.ord+1);
    set(handles.popupmenu8,'Value',strat.conf.mhop+1);
    set(handles.edit14,'String',num2str(strat.conf.d));
    set(handles.edit15,'String',num2str(strat.conf.q));
    set(handles.edit28,'String',strat.customAlg);

    set(handles.edit16,'String',strat.clustStr.C);
    set(handles.edit17,'String',strat.clustStr.B);
    set(handles.edit42,'String',strat.clustStr.Custom);
    set(handles.edit38,'String',strat.clustStr.Ncores);
    set(handles.checkbox3,'Value',strat.clustStr.Multi);
    
    set(handles.dcModel,'Value',strat.DCmodel);
    set(handles.numClusters,'String',num2str(strat.Nclusters));
    set(handles.DCcustom,'String',strat.DCcustom);
    set(handles.HLmap,'String',strat.HLmapping); 
    set(handles.genTopology,'String',strat.Idstr);
    set(handles.edit40,'String',num2str(strat.Bd));

    
    
    
% --- Executes on selection change in popupmenu14.
function popupmenu14_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu14 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu14


i=get(hObject,'Value');
strats=getappdata(handles.figure1,'Strats');
if (i<=length(strats))    
    loadStrat(handles,strats(i)); 
end;

updateCellNumber(handles);

% --- Executes during object creation, after setting all properties.
function popupmenu14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

stratIdx=get(handles.popupmenu14,'Value');
strats=getappdata(handles.figure1,'Strats');
s=saveStrat(handles);
if (isempty(strats))
    strats=s;
else
    strats(stratIdx)=s;
end;

setappdata(handles.figure1,'Strats',strats);

if (sum([strats.enable])>0)
    set(handles.pushbutton5,'Enable','on');
end;


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h=findobj('Enable','on');
for i=1:length(h)
    set(h(i),'Enable','off');
end;

set(handles.pushbutton8,'Enable','on');
set(handles.pushbutton1,'Enable','on');
set(handles.pushbutton6,'Enable','on');
set(handles.edit23,'Enable','on');
set(handles.popupmenu10,'Enable','on');
set(handles.popupmenu11,'Enable','on');
set(handles.popupmenu16,'Enable','on');
set(handles.popupmenu15,'Enable','on');
set(handles.popupmenu18,'Enable','on');
set(handles.text37,'Enable','on');
set(handles.text38,'Enable','on');
set(handles.text40,'Enable','on');
set(handles.text41,'Enable','on');
set(handles.text42,'Enable','on');
set(handles.pushbutton8,'Enable','on');
set(handles.pushbutton9,'Enable','on');
set(handles.pushbutton10,'Enable','on');
set(handles.pushbutton11,'Enable','on');
set(handles.pushbutton13,'Enable','on');
set(handles.edit25,'Enable','on');


Nops=getNops(handles);
[NcellsX NcellsY] = getNcells(handles);
Ncells=NcellsX*NcellsY;
    
strats=getappdata(handles.figure1,'Strats');

setappdata(handles.figure1,'Strats',strats);
setappdata(handles.figure1,'Ncells',Ncells);
setappdata(handles.figure1,'Nops',Nops);

setappdata(handles.figure1,'Duration',str2num(get(handles.edit11,'String')));

AreaXY=xy(str2num(get(handles.edit1,'String')),str2num(get(handles.edit2,'String')));
CellXY=xy(str2num(get(handles.edit5,'String')),str2num(get(handles.edit6,'String')));

setappdata(handles.figure1,'AreaXY',AreaXY);
setappdata(handles.figure1,'CellXY',CellXY);

h=waitbar(0,'Setting up scenario...');
S=readScenarioFigure(handles);
delete(h);


setappdata(handles.figure1,'NumSteps',0);
setappdata(handles.figure1,'Scenario',S);

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

S=getappdata(handles.figure1,'Scenario');

set(handles.pushbutton6,'Enable','off');
len=str2num(get(handles.edit23,'String'));
h=waitbar(0,'Simulating...');
S.run(len);
delete(h);
updatePlot(handles.axes1,handles);
set(handles.pushbutton6,'Enable','on');

numSteps=getappdata(handles.figure1,'NumSteps');
if (isempty(numSteps))
    numSteps=0;
end;
numSteps=numSteps+str2num(get(handles.edit23,'String'));
if (numSteps==S.Duration)
    numSteps=0;
    set(handles.pushbutton6,'Enable','off');
    set(handles.pushbutton1,'Enable','off');
end;

setappdata(handles.figure1,'NumSteps',numSteps);

set(handles.pushbutton8,'Enable','on');



function edit23_Callback(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit23 as text
%        str2double(get(hObject,'String')) returns contents of edit23 as a double


% --- Executes during object creation, after setting all properties.
function edit23_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over popupmenu1.
function popupmenu1_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on key press with focus on edit1 and none of its controls.
function edit1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit1 (see GCBO)
% eventdata  structure with the following fields (see UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2


% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

x=get(handles.popupmenu14,'String');
s=size(x);
x=strvcat(x,sprintf('Strategy %d',s(1)+1));
set(handles.popupmenu14,'String',x);
set(handles.popupmenu15,'String',x);


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

hon=findobj('Enable','on');
hoff=findobj('Enable','off');
for i=1:length(hon)
    set(hon(i),'Enable','off');
end;
for i=1:length(hoff)
    set(hoff(i),'Enable','on');
end;

set(handles.pushbutton6,'Enable','off');
set(handles.pushbutton1,'Enable','off');

% --- Executes on selection change in popupmenu15.
function popupmenu15_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu15 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu15

updatePlot(handles.axes1,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu16.
function popupmenu16_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu16 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu16
updatePlot(handles.axes1,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu16_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function popupmenu17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit24_Callback(hObject, eventdata, handles)
% hObject    handle to edit24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit24 as text
%        str2double(get(hObject,'String')) returns contents of edit24 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit24_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit24 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu18.
function popupmenu18_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu18 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu18
updatePlot(handles.axes1,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu18_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

S=getappdata(handles.figure1,'Scenario');

numSteps=getappdata(handles.figure1,'NumSteps');
set(handles.pushbutton6,'Enable','off');
len=str2num(get(handles.edit23,'String'));
h=waitbar(numSteps/S.Duration,'Simulating...','CreateCancelBtn','setappdata(gcbf,''canceling'',1)');
for i=numSteps:len:S.Duration-len
    waitbar(i/S.Duration,h,'Simulating...');
    if getappdata(h,'canceling')
        break
    end
    S.run(len);
    updatePlot(handles.axes1,handles);
end;
delete(h);
set(handles.pushbutton6,'Enable','on');

if (isempty(numSteps))
    numSteps=0;
end;
numSteps=i;
if (numSteps==S.Duration)
    numSteps=0;
    set(handles.pushbutton6,'Enable','off');
    set(handles.pushbutton1,'Enable','off');
end;

setappdata(handles.figure1,'NumSteps',numSteps);

set(handles.pushbutton8,'Enable','on');



function edit25_Callback(hObject, eventdata, handles)
% hObject    handle to edit25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit25 as text
%        str2double(get(hObject,'String')) returns contents of edit25 as a double


% --- Executes during object creation, after setting all properties.
function edit25_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

figure('Position',[1 1 600 450]);
updatePlot(gca,handles)


% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

S=getappdata(handles.figure1,'Scenario');

checkLabels = {'Save initial C vector:' ...
               'Save initial B vector:' ...
               'Save I matrix:' ...
               'Save current C Vector:' ...
               'Save current B vector:' ...
               'Save processor usage vector:' ...
               'Save number of users vector:' ...
               'Save number of feasible users vector:'}; 
varNames = {'Cini','Bini','I','C','B','Pusage','Ntotal','Nfeasibles'}; 
for i=1:length(S.Strategies)
    Cini(i,:)=S.Strategies(i).Cloud.CInit;
    Bini(i,:)=S.Strategies(i).Cloud.BInit;
    C(i,:)=S.Strategies(i).Cloud.C;
    B(i,:)=S.Strategies(i).Cloud.B;
    I(i,:,:)=S.Strategies(i).Cloud.I;
    Pusage(i,:)=S.Strategies(i).vectorUsageProcessors();
    Nfeas(i,:)=S.Strategies(i).vectorFeasibles();
    Ntot(i,:)=S.Strategies(i).vectorFeasibles();
end
items = {Cini,Bini,I,C,B,Pusage,Ntot,Nfeas};
export2wsdlg(checkLabels,varNames,items,...
             'Save Variables to Workspace');


% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

temp=gcf;
[file path]=uigetfile('*.scn','Load Scenario');
if (file~=0)
    hgload([path file]);
end;
close(temp);



function edit28_Callback(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit28 as text
%        str2double(get(hObject,'String')) returns contents of edit28 as a double


% --- Executes during object creation, after setting all properties.
function edit28_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit28 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
x=computePlot(handles);
[file path]=uiputfile('*.mat','Save Plot');
if (file~=0)
    save(x, [path file]);
end;



function edit30_Callback(hObject, eventdata, handles)
% hObject    handle to edit30 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit30 as text
%        str2double(get(hObject,'String')) returns contents of edit30 as a double


% --- Executes during object creation, after setting all properties.
function edit30_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit30 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit31_Callback(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit31 as text
%        str2double(get(hObject,'String')) returns contents of edit31 as a double


% --- Executes during object creation, after setting all properties.
function edit31_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit31 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit32_Callback(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit32 as text
%        str2double(get(hObject,'String')) returns contents of edit32 as a double


% --- Executes during object creation, after setting all properties.
function edit32_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit32 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit33_Callback(hObject, eventdata, handles)
% hObject    handle to edit33 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit33 as text
%        str2double(get(hObject,'String')) returns contents of edit33 as a double


% --- Executes during object creation, after setting all properties.
function edit33_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit33 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes during object creation, after setting all properties.
function DCcustom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to DCcustom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit35_Callback(hObject, eventdata, handles)
% hObject    handle to edit35 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit35 as text
%        str2double(get(hObject,'String')) returns contents of edit35 as a double


% --- Executes during object creation, after setting all properties.
function edit35_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit35 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function DCcustom_Callback(hObject, eventdata, handles)
% hObject    handle to DCcustom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of DCcustom as text
%        str2double(get(hObject,'String')) returns contents of DCcustom as a double
updateCellNumber(handles);


function clustMat_Callback(hObject, eventdata, handles)
% hObject    handle to clustMat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of clustMat as text
%        str2double(get(hObject,'String')) returns contents of clustMat as a double
updateCellNumber(handles);


% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
strats=getappdata(handles.figure1,'Strats');
[file path]=uiputfile('*.mat','Save Strategies');
if (file~=0)
    save([path file],'strats');
end;


% --- Executes on button press in pushbutton15.
function pushbutton15_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file path]=uigetfile('*.mat','Load Strategies');
if (file~=0)
    x=load([path file]);
end;
strats=x.strats;
setappdata(handles.figure1,'Strats',strats);

x=[]
for i=1:length(strats)
    x=strvcat(x,sprintf('Strategy %d',i));
end

set(handles.popupmenu14,'String',x);
popupmenu14_Callback(hObject, eventdata, handles);



function HLmap_Callback(hObject, eventdata, handles)
% hObject    handle to HLmap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of HLmap as text
%        str2double(get(hObject,'String')) returns contents of HLmap as a double


% --- Executes during object creation, after setting all properties.
function HLmap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to HLmap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in dcModel.
function dcModel_Callback(hObject, eventdata, handles)
% hObject    handle to dcModel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns dcModel contents as cell array
%        contents{get(hObject,'Value')} returns selected item from dcModel
if (get(hObject,'Value')==5)
    set(handles.DCcustom,'Enable','on');
else
    set(handles.DCcustom,'Enable','off');
end
if (get(hObject,'Value')==4)
    set(handles.genTopology,'Enable','on');
else
    set(handles.genTopology,'Enable','off');
end

% --- Executes during object creation, after setting all properties.
function dcModel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dcModel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function numClusters_Callback(hObject, eventdata, handles)
% hObject    handle to numClusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numClusters as text
%        str2double(get(hObject,'String')) returns contents of numClusters as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function numClusters_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numClusters (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3
if (get(hObject,'Value')==1)
    set(handles.text49,'Enable','off');
    set(handles.edit42,'Enable','off');
    set(handles.edit16,'Enable','on');
    set(handles.edit17,'Enable','on');
    set(handles.edit38,'Enable','on');
else
    set(handles.text49,'Enable','on');
    set(handles.edit42,'Enable','on');
    set(handles.edit16,'Enable','off');
    set(handles.edit17,'Enable','off');
    set(handles.edit38,'Enable','off');
 end
updateCellNumber(handles)

function edit38_Callback(hObject, eventdata, handles)
% hObject    handle to edit38 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit38 as text
%        str2double(get(hObject,'String')) returns contents of edit38 as a double
updateCellNumber(handles)

% --- Executes during object creation, after setting all properties.
function edit38_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit38 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called



function genTopology_Callback(hObject, eventdata, handles)
% hObject    handle to genTopology (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of genTopology as text
%        str2double(get(hObject,'String')) returns contents of genTopology as a double


% --- Executes during object creation, after setting all properties.
function genTopology_CreateFcn(hObject, eventdata, handles)
% hObject    handle to genTopology (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit40_Callback(hObject, eventdata, handles)
% hObject    handle to edit40 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit40 as text
%        str2double(get(hObject,'String')) returns contents of edit40 as a double


% --- Executes during object creation, after setting all properties.
function edit40_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit40 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit42_Callback(hObject, eventdata, handles)
% hObject    handle to edit42 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit42 as text
%        str2double(get(hObject,'String')) returns contents of edit42 as a double


% --- Executes during object creation, after setting all properties.
function edit42_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit42 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
