function plotSDR11(S,title)

figure;

sIdx=[1 2 3 5 6 4];
labels=strvcat('Strategy 1.a','Strategy 1.b','Strategy 2.a','Strategy 2.b','Strategy 3.a','Strategy 3.b');

marks=strvcat('k-','k:','r-','r:','b-','b:');
service=[64 128 384 1024];


%% Total users
TotalUsers=zeros(6,S.Duration);
for i=1:6
    TotalUsers(i,:)=S.Strategies(sIdx(i)).vectorFeasibles();
    plot(1:S.Duration,TotalUsers(i,:),marks(i,:));
    hold on;
end;
hold off;
xLabel('Num users entering');
yLabel('Num users accepted');
legend(labels);

%% Active servers
figure
NumProcs=zeros(6,S.Duration);
for i=1:6
    NumProcs(i,:)=S.Strategies(sIdx(i)).vectorActiveProcessors();
    plot(1:S.Duration,NumProcs(i,:),marks(i,:));
    hold on;
end;
hold off;
legend(labels);
xLabel('Num users entering');
yLabel('Num active servers');

%% Usage
figure
usageProcs=zeros(6,S.Duration);
for i=1:6
    usageProcs(i,:)=S.Strategies(sIdx(i)).vectorUsageProcessors();
    plot(1:S.Duration,usageProcs(i,:),marks(i,:));
    hold on;
end;
hold off;
legend(labels);
xLabel('Num users entering');
yLabel('Average cloud usage');


%% Per operator

for i=1:6   
    for op=1:2
        for s=1:4            
            fprintf('Strategy %d. Operator %d. Service %d kbps = %d\n',sIdx(i),op,service(s),S.Strategies(sIdx(i)).numFeasibles(op,s));                        
        end;
        fprintf('Strategy %d. Operator %d = %d\n',sIdx(i),op,S.Strategies(sIdx(i)).numFeasibles(op,0));                        
    end;
    for s=1:4            
        fprintf('Strategy %d. Service %d kbps = %d\n',sIdx(i),service(s),S.Strategies(sIdx(i)).numFeasibles(0,s));                        
    end;   
    fprintf('Strategy %d = %d\n',sIdx(i),S.Strategies(sIdx(i)).numFeasibles(0,0));
end



