clear;

Nclusters=16;
Nusers=100;
Ncores=4;
Cx=9600; % C de cada core
Bx=100000; % BW entre cores

Bd=10; % BW entre clusters

[c b]=model_utran(1);

%modelo multicore
Cc=Cx.*ones(1,Ncores);
Bc=[1000000.*ones(1,Ncores) Bx zeros(1,Ncores^2-1-Ncores)];
Ic=diag(1:Ncores)+(Ncores+1)*(ones(Ncores,Ncores)-eye(Ncores));

%torus
[Ct Bt It]=torus(Cc,Bc,Ic,Nclusters,Bd);

%sin conectar
[Cs Bs Is]=repeatClusters(Nclusters,Cc,Bc,Ic);

%variables mapping
alg=1; % algorithm selector: 0=gw-mapping, 1=tw-mapping, 2=opt-mapping
ord=0; % pre-processing order: 0=no order, 1=capacity order, 2=bw order
mhop=0; % enable multi-hop: 0=no, 1=yes
w=1;
weight=0;
q=0.5;

constraints=ones(length(c),length(Ct));
feasibles=false(2,Nusers);
for i=1:Nusers
    [cost result ord Ct Bt] = mapper_matlab3(Ct,It,Bt,c,b,1,w,q,weight,ord,mhop,constraints);
    if (cost<1000000)
        feasibles(1,i)=true;
        fprintf('%d yes\n',i);
    else        
        fprintf('%d no\n',i); 
    end
    
   % [cost result ord Cs Bs] = mapper_matlab3(Cs,Is,Bs,c,b,0,w,q,weight,ord,mhop,constraints);
   % if (cost<1000000)
   %     feasibles(2,i)=true;
   % end
end

plot(1:Nusers,cumsum(feasibles,2));
legend('Torus','Simple')
fprintf('Torus: %g. Simple: %g\n',sum(feasibles(1,:)),sum(feasibles(2,:)));

