function S=readScenarioFigure(handles)
    global posGauss;
    global opVect;
    global sEqual;
    global sVect;
    global mm1Opts;

    strats=getappdata(handles.figure1,'Strats');

    Ns=length(strats);
    for i=1:Ns   
        if (strats(i).enable)
            
            if (isempty(strats(i).customAlg))
                mapConf = strats(i).conf;
            else
                f=str2func(strats(i).customAlg);
                mapConf = f();
            end;
                [C B I]=cluster2DC(strats(i));           
                
                NCvect=min(ceil(500/strats(i).Nclusters),strats(i).Nclusters);
                duration=getappdata(handles.figure1,'Duration');
                win=duration;
                if (NCvect==ceil(500/strats(i).Nclusters))
                    win=min(1000,duration);
                end;
                
                cloud = Cloud(C,B,I,NCvect,duration,win,strats(i).Nclusters,length(strats(i).clust.C));
                [fu args]=strtok(strats(i).HLmapping,'(');
                Strat(i)=Strategy(mapConf,cloud,str2func(fu),args(2:(length(args)-1)));            
        end;
    end;

    area=getappdata(handles.figure1,'AreaXY');
    cell=getappdata(handles.figure1,'CellXY');

    if get(handles.popupmenu4,'Value')==1
        e=@event_allwaysenter;
    elseif get(handles.popupmenu4,'Value')==2
        e=@event_mm1;
        mm1Opts=str2num(get(handles.edit12,'String'));
    elseif get(handles.popupmenu4,'Value')==3
        e=@event_mm1multiple;
        mm1Opts=str2num(get(handles.edit12,'String'));
    else 
        e=str2func(get(handles.edit12,'String'));
    end;

    if get(handles.popupmenu1,'Value')==1
        p=@position_uniform;
    elseif get(handles.popupmenu1,'Value')==2
        posGauss=str2num(get(handles.edit8,'String'));
        p=@position_gauss;
    else 
        p=str2func(get(handles.edit8,'String'));
    end;

    if get(handles.popupmenu2,'Value')==1
        o=@operator_uniform;
    elseif get(handles.popupmenu2,'Value')==2
        opVect=str2num(get(handles.edit9,'String'));
        o=@operator_vector;
    else 
        a=get(handles.edit9,'String');
        o=str2func(a((find(',')+1):length(a)));
    end;

    if get(handles.popupmenu3,'Value')==1
        sEqual=str2num(get(handles.edit10,'String'));
        s=@service_equal;
    elseif get(handles.popupmenu3,'Value')==2
        sVect=str2num(get(handles.edit10,'String'));
        s=@service_vector;
    else 
        s=str2func(get(handles.edit10,'String'));
    end;

    S=Scenario(duration,e,p,o,getappdata(handles.figure1,'Nops'),s,area,cell,Strat);

