function [I B] = resource_model_transformation(Bx, arch)

    Nx = size(Bx,1);
    inf = 10^8;
    
	% initialization
	for i=1:(Nx*Nx)
		B(i) = 0;
    end;

	if (arch == 0)
		% full-duplex interprocessor communications
		ucount = Nx+1;
		dcount = Nx*Nx;
		for i=1:Nx
			for j=1:Nx
				if (i == j)
					I(i,i) = i;
					B(i) = inf;
                else
					if (Bx(i,j) > 0)
						I(i,j) = ucount;
						B(ucount) = Bx(i,j);
						ucount = ucount+1;
                    else
						I(i,j) = dcount;
						dcount = dcount-1;
                    end;
                end;
            end;
        end;
    elseif (arch == 2)
		% half-duplex interprocessor communications
		ucount = Nx+1;
		dcount = Nx*Nx;
		for i=1:Nx
			for j=i:Nx
				if (i == j)
					I(i,i) = i;
					B(i) = inf;
                else
					if (Bx(i,j) > 0)
						I(i,j) = ucount;
						I(j,i) = ucount;
						B(ucount) = Bx(i,j);
						ucount = ucount+1;
                    else
						I(i,j) = dcount;
						I(j,i) = dcount;
						dcount = dcount-1;
                    end;
                end;
            end;
        end;
                   
    elseif (arch == 3)
		% single shared bus
		ucount = Nx+1;
		for i=1:Nx
			for j=1:Nx
				if (i == j)
					I(i,i) = i;
					B(i) = inf;
                elseif (Bx(i,j) > 0)
					I(i,j) = ucount;	% assuming that processors have access to a single shared bus of bandwidth Bx(i,j)
                    B(ucount) = Bx(i,j);
                else
                    I(i,j) = Nx*Nx;
                end;
            end;
        end;
		%B(ucount) = Bx_bus;
    end;
    